{==========================================================================}
{=                 Modul FLI - na podstawie PC Kurier 16/94               =}
{= Procedura PlayFli - odgrywa animacje , na bierzaco odczytujac dane z   =}
{= dysku. Jest to robione szybko, jednak nie mozliwe jest juz w tym czasie=}
{= np odgrywac MOD-a. Dlatego, wykorzystujac pamiec XMS, mozna uzywac pro-=}
{= cedur LoadFliXMS i PlayFLIXMS - jest to o wiele szybsze (patrz programy=}
{= przykladowe) bowiem najpierw umieszczamy animacje w pamieci, natomiast =}
{= pozniej ja odgrywamy, pobierajac dane nie z dysku, a z XMS.            =}
{==========================================================================}

unit FLI;

interface

  procedure PlayFLI(fname:string);
  procedure LoadFliXms(fname:string;var handle:word);
  procedure PlayFliXms(handle:word);

implementation
uses xms,palette;
type
  FliHeader=record
    size:longint;
    htype:word;
    framecount:word;
    width:word;
    height:word;
    bitsperpixel:word;
    flags:integer;
    speed:integer;
    nexthead:longint;
    framesintable:longint;
    hfile:integer;
    hframe1offset:longint;
    strokes:longint;
    session:longint;
    reserved:array[1..88] of byte;
  end;
  FrameHeader=record
    size:longint;
    ftype:word;
    chunks:word;
    expand:array[1..8] of byte;
  end;
  ChunkHeader=record
    size:longint;
    id:word;
  end;
  Buffer=array[1..65535] of byte;
var
  Buf:^Buffer;
  Pal:^PALettetype;
  H:FLIHeader;
  FH:FrameHeader;
  CH:ChunkHeader;
  I,J:Word;
  Speed: word;
  f:file;
  fname:string;
  FirstFrame:longint;
  flixmshandle:word;
  position:longint;

function SetGraphMode:word; assembler;
asm
  mov ax,0013h
  int 10h
  mov ah,0fh
  int 10h
  xor ah,ah
end;

procedure SetTextMode; assembler;
asm
  mov ax,3h
  int 10h
end;

procedure WaitForScreen; assembler;
asm
  mov dx,3dah
@wait1:
  in al,dx
  test al,8
  jnz @wait1
@wait2:
  in al,dx
  test al,8
  jz @wait2
end;

procedure waiting; assembler;
asm
  mov cx,speed
  jcxz @end
  dec cx
@wait:
  call waitforscreen
  loop @wait
@end:
end;

procedure DecodeFli_Color; assembler;
asm
  les ax,pal
  mov bx,es
  mov dx,ax
  and ax,15
  mov di,ax
  shr dx,4
  add bx,dx
  mov es,bx
  push ds
  lds ax,buf
  mov bx,ds
  mov dx,ax
  and ax,15
  mov si,ax
  shr dx,4
  add bx,dx
  mov ds,bx
  cld
  lodsw
  mov bx,ax
  test bx,bx
  jmp @endu
@u:
  lodsb
  add di,ax
  add di,ax
  add di,ax
  lodsb
  or al,al
  jnz @u2
  mov ax,256
@u2:
  mov cx,ax
  add cx,ax
  add cx,ax
  rep movsb
  dec bx
@endu:
  jnz @u
  sub di,768
  mov si,di
  push es
  pop ds
  mov cx,256
  mov bl,0
@setpal:
  mov dx,3c8h
  mov al,bl
  out dx,al
  inc dx
  lodsb
  out dx,al
  lodsb
  out dx,al
  lodsb
  out dx,al
  inc bl
  loop @setpal
  pop ds
end;

procedure DecodeFLI_BLACK; assembler;
asm
  mov cx,32000
  mov ax,0A000h
  mov es,ax
  xor ax,ax
  mov di,ax
  rep stosw
  call waiting
end;

procedure DecodeFLI_Brun; assembler;
var linecount:word;
asm
  call waitforscreen
  mov linecount,200
  mov ax,0A000h
  mov es,ax
  xor di,di
  push ds
  lds ax,buf
  mov bx,ds
  mov dx,ax
  and ax,15
  mov si,ax
  shr dx,4
  add bx,dx
  mov ds,bx
  cld
  mov dx,di
  xor ah,ah
@linelp:
  mov di,dx
  lodsb
  mov bl,al
  test bl,bl
  jmp @endulcloop
@ulcloop:
  lodsb
  test al,al
  js @ucopy
  mov cx,ax
  lodsb
  rep stosb
  dec bl
  jnz @ulcloop
  jmp @ulcout
@ucopy:
  neg al
  mov cx,ax
  rep movsb
  dec bl
@endulcloop:
  jnz @ulcloop
@ulcout:
  add dx,320
  dec linecount
  jnz @linelp
  pop ds
  call waiting
end;

procedure decodeFLI_LC; assembler;
var linecount:word;
asm
  call waitforscreen
  mov ax,0a000h
  mov es,ax
  xor di,di
  push ds
  lds ax,buf
  mov bx,ds
  mov dx,ax
  and ax,15
  mov si,ax
  shr dx,4
  add bx,dx
  mov ds,bx
  cld
  lodsw
  mov dx,320
  mul dx
  add di,ax
  lodsw
  mov linecount,ax
  mov dx,di
  xor ah,ah
@linelp:
  mov di,dx
  lodsb
  mov bl,al
  test bl,bl
  jmp @endulcloop
@ulcloop:
  lodsb
  add di,ax
  lodsb
  test al,al
  js @ulcrun
  mov cx,ax
  rep movsb
  dec bl
  jnz @ulcloop
  jmp @ulcout
@ulcrun:
  neg al
  mov cx,ax
  lodsb
  rep stosb
  dec bl
@endulcloop:
  jnz @ulcloop
@ulcout:
  add dx,320
  dec linecount
  jnz @linelp
  pop ds
  call waiting
end;

procedure DecodeFLI_Copy; assembler;
asm
  call waitforscreen
  mov ax,0A000h
  mov es,ax
  xor di,di
  push ds
  lds ax,buf
  mov bx,ds
  mov dx,ax
  and ax,15
  mov si,ax
  shr dx,4
  add bx,dx
  mov ds,bx
  mov cx,32000
  rep movsb
  pop ds
  call waiting
end;

procedure PlayFLI;
begin
  assign(f,fname);
  {$I-}
  reset(f,1);
  {$I+}
  if ioresult<>0 then halt;
  {$I-}
  blockread(f,h,sizeof(h)); {$I+}
  if ioresult<>0 then halt(3);
  if h.htype<>$AF11 then begin
    close(f); halt(4);
  end;
  New(buf); New(pal);
  speed:=h.speed;
  firstframe:=filepos(f);
    for i:=1 to h.framecount do begin
      {$I-} blockread(f,fh,sizeof(fh)); {$I+}
      if fh.chunks>0 then
        for j:=1 to fh.chunks do begin
          {$I-} blockread(f,ch,sizeof(ch)); {$I+}
        {$I-} blockread(f,buf^,ch.size-sizeof(ch)); {$I+}
        case ch.id of
          11:decodefli_color;
          12:decodefli_lc;
          13:decodefli_black;
          15:decodefli_brun;
          16:decodefli_copy;
        end;
        end else waiting;
      end;
    close(f);
    dispose(pal); dispose(buf);
end;

procedure blockread_(var F: word; var Buf; Count: Word);
begin
  xms2mem(f,position,buf,count);
  position:=position+count;
end;

procedure PlayFLIXMS;
begin
  blockread_(handle,h,sizeof(h));
  if h.htype<>$AF11 then halt(4);
  New(buf); New(pal);
  speed:=h.speed;
  firstframe:=position;
    for i:=1 to h.framecount do begin
      blockread_(handle,fh,sizeof(fh));
      if fh.chunks>0 then
        for j:=1 to fh.chunks do begin
          blockread_(handle,ch,sizeof(ch));
          blockread_(handle,buf^,ch.size-sizeof(ch));
        case ch.id of
          11:decodefli_color;
          12:decodefli_lc;
          13:decodefli_black;
          15:decodefli_brun;
          16:decodefli_copy;
        end;
        end else waiting;
      end;
  dispose(pal); dispose(buf);
  xmsfreemem(handle);
end;

procedure LoadFliXms;
var bufor:array[1..1024]of byte;
    r:word;
    size:longint;
    ofset:longint;
begin
  assign(f,fname);
  {$I-}
  reset(f,1);
  {$I+}
  if ioresult<>0 then halt;
  {$I-}
  size:=filesize(f);
  ofset:=0;
  xmsgetmem(handle,size);
  repeat
    blockread(f,bufor,1024,r);
    mem2xms(bufor, Handle, ofset,r);
    ofset:=ofset+r;
  until r<1024;
  close(f);
end;
end.